import { world, BlockPermutation } from "@minecraft/server"

world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry }) => {
  blockComponentRegistry.registerCustomComponent("jurassic:turn_into_air", {
    beforeOnPlayerPlace: data => {
      if (data.block.above().isAir === false) {
        data.cancel = true;
      }
      const blockPlacements = new Map([
        ["jurassic:tall_cycad", (block) => block.above(1).setPermutation(BlockPermutation.resolve("jurassic:tall_cycad_top").withState("jurassic:double_block", "top"))],
        ["jurassic:cultivator_block", (block) => block.above(1).setPermutation(BlockPermutation.resolve("jurassic:cultivator_top").withState("jurassic:double_block", "top"))],
        ["jurassic:tall_panicum", (block) => block.above(1).setPermutation(BlockPermutation.resolve("jurassic:tall_panicum_top").withState("jurassic:double_block", "top"))],
      ]);
      const placeFunct = blockPlacements.get(data.permutationToPlace.type.id);
      if (placeFunct && data.block.above().isAir === true) {
        placeFunct(data.block);
      }
    },
    onPlayerDestroy: data => {
      const blockPlacements = new Map([
        ["jurassic:tall_cycad", (block) => block.above(1).setPermutation(BlockPermutation.resolve("jurassic:tall_cycad").withState("jurassic:double_block", "top"))],
        ["jurassic:cultivator_block", (block) => block.above(1).setPermutation(BlockPermutation.resolve("jurassic:cultivator").withState("jurassic:double_block", "top"))],
        ["jurassic:tall_panicum", (block) => block.above(1).setPermutation(BlockPermutation.resolve("jurassic:tall_panicum").withState("jurassic:double_block", "top"))],
      ]);
      const placeFunct = blockPlacements.get(data.destroyedBlockPermutation.type.id);
      data.block.dimension.runCommand(`setblock ${data.block.location.x} ${data.block.location.y - 1} ${data.block.location.z} air[] destroy`);
    },
  });
});