import { world, EquipmentSlot, GameMode } from "@minecraft/server";

const plants = [
  { id: "minecraft:apple" },
  { id: "minecraft:carrot" },
  { id: "minecraft:item.beetroot" },
  { id: "minecraft:potato" },
  { id: "minecraft:wheat" },
  { id: "minecraft:sweet_berries" }
];
const fishes = [
  { id: "minecraft:cod" },
  { id: "minecraft:salmon" },
  { id: "minecraft:tropical_fish" },
  { id: "minecraft:pufferfish" },
  { id: "jurassic:raw_coelacanth" },
  { id: "jurassic:raw_nautilus" }
];

const meats = [
  { id: "minecraft:beef" },
  { id: "minecraft:rabbit" },
  { id: "minecraft:chicken" },
  { id: "minecraft:porkchop" },
  { id: "minecraft:mutton" }
]

world.beforeEvents.worldInitialize.subscribe(data => {
  data.blockComponentRegistry.registerCustomComponent('jurassic:empty_feeder', {
    onPlayerInteract(event) {
      const { block, dimension, player, } = event;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);
      if (selectItem?.typeId === "minecraft:wheat" || selectItem?.typeId === "minecraft:apple" || selectItem?.typeId === "minecraft:item.beetroot" || selectItem?.typeId === "minecraft:carrot" || selectItem?.typeId === "minecraft:potato" || selectItem?.typeId === "minecraft:sweet_berries") {
        if (!selectItem.hasItem()) return;

        if (player.getGameMode() !== GameMode.creative) {
          if (selectItem.amount > 1) {
            selectItem.amount--;
          } else {
            selectItem.setItem(undefined);
          }
        }
        dimension.spawnParticle("jurassic:completion_particle_green", block.center());
        block.setType("jurassic:barely_filled_plant_feeder");
      }

      if (selectItem?.typeId === "minecraft:cod" || selectItem?.typeId === "minecraft:salmon" || selectItem?.typeId === "minecraft:tropical_fish" || selectItem?.typeId === "minecraft:pufferfish" || selectItem?.typeId === "jurassic:raw_coelacanth" || selectItem?.typeId === "jurassic:raw_nautilus") {
        if (!selectItem.hasItem()) return;

        if (player.getGameMode() !== GameMode.creative) {
          if (selectItem.amount > 1) {
            selectItem.amount--;
          } else {
            selectItem.setItem(undefined);
          }
        }
        dimension.spawnParticle("jurassic:completion_particle_aqua", block.center());
        block.setType("jurassic:barely_filled_fish_feeder");
      }

      if (selectItem?.typeId === "minecraft:chicken" || selectItem?.typeId === "minecraft:beef" || selectItem?.typeId === "minecraft:porkchop" || selectItem?.typeId === "minecraft:mutton" || selectItem?.typeId === "minecraft:rabbit") {
        if (!selectItem.hasItem()) return;

        if (player.getGameMode() !== GameMode.creative) {
          if (selectItem.amount > 1) {
            selectItem.amount--;
          } else {
            selectItem.setItem(undefined);
          }
        }
        dimension.spawnParticle("jurassic:completion_particle_red", block.center());
        block.setType("jurassic:barely_filled_meat_feeder");
      }
    }
  });
});