import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
  data.blockComponentRegistry.registerCustomComponent('jurassic:fish_feeder1', {
    onPlayerInteract(event) {
      const { block, dimension, player, } = event;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

      if (selectItem?.typeId === "minecraft:cod" || selectItem?.typeId === "minecraft:salmon" || selectItem?.typeId === "minecraft:tropical_fish" || selectItem?.typeId === "minecraft:pufferfish" || selectItem?.typeId === "jurassic:raw_coelacanth" || selectItem?.typeId === "jurassic:raw_nautilus") {
        if (!selectItem.hasItem()) return;

        if (player.getGameMode() !== GameMode.creative) {
          if (selectItem.amount > 1) {
            selectItem.amount--;
          } else {
            selectItem.setItem(undefined);
          }
        }
        dimension.spawnParticle("jurassic:completion_particle_aqua", block.center());
        block.setType("jurassic:decently_filled_fish_feeder");
      }
    }
  });
});