import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
  data.blockComponentRegistry.registerCustomComponent('jurassic:meat_feeder1', {
    onPlayerInteract(event) {
      const { block, dimension, player, } = event;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

      if (selectItem?.typeId === "minecraft:chicken" || selectItem?.typeId === "minecraft:beef" || selectItem?.typeId === "minecraft:porkchop" || selectItem?.typeId === "minecraft:mutton" || selectItem?.typeId === "minecraft:rabbit") {
        if (!selectItem.hasItem()) return;

        if (player.getGameMode() !== GameMode.creative) {
          if (selectItem.amount > 1) {
            selectItem.amount--;
          } else {
            selectItem.setItem(undefined);
          }
        }
        dimension.spawnParticle("jurassic:completion_particle_red", block.center());
        block.setType("jurassic:decently_filled_meat_feeder");
      }
    }
  });
});