import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
  data.blockComponentRegistry.registerCustomComponent('jurassic:plant_feeder2', {
    onPlayerInteract(event) {
      const { block, dimension, player, } = event;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);
      if (selectItem?.typeId === "minecraft:wheat" || selectItem?.typeId === "minecraft:apple" || selectItem?.typeId === "minecraft:item.beetroot" || selectItem?.typeId === "minecraft:carrot" || selectItem?.typeId === "minecraft:potato" || selectItem?.typeId === "minecraft:sweet_berries") {
        if (!selectItem.hasItem()) return;

        if (player.getGameMode() !== GameMode.creative) {
          if (selectItem.amount > 1) {
            selectItem.amount--;
          } else {
            selectItem.setItem(undefined);
          }
        }
        dimension.spawnParticle("jurassic:completion_particle_green", block.center());
        block.setType("jurassic:halfway_filled_plant_feeder");
      }
    }
  });
});