import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cultivator_interact', {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "minecraft:milk_bucket") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());
                block.setPermutation(block.permutation.withState('jurassic:milk', true));
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "jurassic:montsechia_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_montsechia");
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "jurassic:tall_cycad_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_tall_cycad");
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "jurassic:scale_tree_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_scale_tree");
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "jurassic:coelacanth_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_coelacanth");
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "jurassic:nautilus_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_nautilus");
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "jurassic:mammoth_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_mammoth");
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "jurassic:smilodon_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_smilodon");
            }

            if (block.permutation.getState('jurassic:milk') && selectItem?.typeId === "minecraft:egg") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());
                block.setPermutation(block.permutation.withState('jurassic:egg', true));
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:dna_dilo") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_dilophosaurus");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:spinosaurus_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_spinosaurus");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:velociraptor_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_velociraptor");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:mosasaurus_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_mosasaurus");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:plesiosaurus_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_plesiosaurus");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:brachiosaurus_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_brachiosaurus");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:stegosaurus_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_stegosaurus");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:triceratops_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_triceratops");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:pteranodon_dna") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_pteranodon");
            }

            if (block.permutation.getState('jurassic:egg') && selectItem?.typeId === "jurassic:dodo_full") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:cultivator_dodo");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:timer', {
        onTick(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:timer')) {
                block.setPermutation(block.permutation.withState('jurassic:loot', true));
                block.setPermutation(block.permutation.withState('jurassic:timer', false));
                dimension.spawnParticle("jurassic:completion_particle_green", block.center());
            }
        }
    });
});