import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_dilophosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:dilo_fossil" || selectItem?.typeId === "jurassic:fdilo_tooth") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_dilophosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_dilophosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:dilo_fossil" || selectItem?.typeId === "jurassic:fdilo_tooth") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_dilophosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_dilophosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:dilo_fossil" || selectItem?.typeId === "jurassic:fdilo_tooth") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_dilophosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_spinosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:spinosaurus_fossil" || selectItem?.typeId === "jurassic:spinosaurus_tooth_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_spinosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_spinosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:spinosaurus_fossil" || selectItem?.typeId === "jurassic:spinosaurus_tooth_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_spinosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_spinosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:spinosaurus_fossil" || selectItem?.typeId === "jurassic:spinosaurus_tooth_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_spinosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_velociraptor", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:velociraptor_fossil" || selectItem?.typeId === "jurassic:velociraptor_tooth_fossil" || selectItem?.typeId === "jurassic:fossil_velociraptor_claw") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_velociraptor");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_velociraptor", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:velociraptor_fossil" || selectItem?.typeId === "jurassic:velociraptor_tooth_fossil" || selectItem?.typeId === "jurassic:fossil_velociraptor_claw") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_velociraptor");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_velociraptor", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:velociraptor_fossil" || selectItem?.typeId === "jurassic:velociraptor_tooth_fossil" || selectItem?.typeId === "jurassic:fossil_velociraptor_claw") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_velociraptor");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});