import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_dodo", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:dodo_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_dodo");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_dodo", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:dodo_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_dodo");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_dodo", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:dodo_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_dodo");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_mammoth", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:mammoth_fossil" || selectItem?.typeId === "jurassic:fossil_mammoth_tusk") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_mammoth");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_mammoth", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:mammoth_fossil" || selectItem?.typeId === "jurassic:fossil_mammoth_tusk") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_mammoth");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_mammoth", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:mammoth_fossil" || selectItem?.typeId === "jurassic:fossil_mammoth_tusk") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_mammoth");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_smilodon", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:smilodon_fossil" || selectItem?.typeId === "jurassic:fossil_sabre_tooth") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_smilodon");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_smilodon", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:smilodon_fossil" || selectItem?.typeId === "jurassic:fossil_sabre_tooth") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_smilodon");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_smilodon", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:smilodon_fossil" || selectItem?.typeId === "jurassic:fossil_sabre_tooth") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_smilodon");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});