import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_brachiosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:brachiosaurus_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_brachiosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_brachiosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:brachiosaurus_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_brachiosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_brachiosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:brachiosaurus_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_brachiosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_stegosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:stego_fossil" || selectItem?.typeId === "jurassic:fossilthagomizer" || selectItem?.typeId === "jurassic:fossil_stego_foot") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_stegosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_stegosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:stego_fossil" || selectItem?.typeId === "jurassic:fossilthagomizer" || selectItem?.typeId === "jurassic:fossil_stego_foot") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_stegosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_stegosaurus", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:stego_fossil" || selectItem?.typeId === "jurassic:fossilthagomizer" || selectItem?.typeId === "jurassic:fossil_stego_foot") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_stegosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_triceratops", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:triceratops_fossil" || selectItem?.typeId === "jurassic:fossil_triceratops_horn") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_triceratops");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_triceratops", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:triceratops_fossil" || selectItem?.typeId === "jurassic:fossil_triceratops_horn") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_triceratops");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_triceratops", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:triceratops_fossil" || selectItem?.typeId === "jurassic:fossil_triceratops_horn") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_triceratops");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});