import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_scale_tree", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:petrified_scale_log") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_scale_tree");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_scale_tree", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:petrified_scale_log") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_scale_tree");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_scale_tree", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:petrified_scale_log") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_scale_tree");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_tall_cycad", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:cycad_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_tall_cycad");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_tall_cycad", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:cycad_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_tall_cycad");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_tall_cycad", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:cycad_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_tall_cycad");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv1_montsechia", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:montsechia_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_montsechia");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv2_montsechia", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:montsechia_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_montsechia");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent("jurassic:lv3_montsechia", {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:montsechia_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_montsechia");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});