import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:extractor_interact', {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "jurassic:storage_disk0") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());
                block.setPermutation(block.permutation.withState('jurassic:disc', true));
            }

            if (selectItem?.typeId === "jurassic:syringe") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());
                block.setPermutation(block.permutation.withState('jurassic:syringe', true));
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:petrified_scale_log") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_scale_tree");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:cycad_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_tall_cycad");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:montsechia_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_montsechia");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:coelacanth_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_coelacanth");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:fossil_nautilus_shell") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_nautilus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:mosasaurus_fossil" || selectItem?.typeId === "jurassic:mosasaurus_tooth_fossil") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_mosasaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:mosasaurus_bones" || selectItem?.typeId === "jurassic:mosasaurus_tooth" || selectItem?.typeId === "jurassic:mosasaurus_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_mosasaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:plesiosaurus_fossil" || selectItem?.typeId === "jurassic:plesiosaurus_tooth_fossil") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_plesiosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:plesiosaurus_bones" || selectItem?.typeId === "jurassic:plesiosaurus_tooth" || selectItem?.typeId === "jurassic:plesiosaurus_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_plesiosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:dilo_fossil" || selectItem?.typeId === "jurassic:fdilo_tooth") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_dilophosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:dilo_bones" || selectItem?.typeId === "jurassic:dilo_tooth" || selectItem?.typeId === "jurassic:dilo_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_dilophosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:spinosaurus_fossil" || selectItem?.typeId === "jurassic:spinosaurus_tooth_fossil") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_spinosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:spinosaurus_bones" || selectItem?.typeId === "jurassic:spinosaurus_tooth" || selectItem?.typeId === "jurassic:spinosaurus_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_spinosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:velociraptor_fossil" || selectItem?.typeId === "jurassic:velociraptor_tooth_fossil" || selectItem?.typeId === "jurassic:fossil_velociraptor_claw") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_velociraptor");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:velociraptor_bones" || selectItem?.typeId === "jurassic:velociraptor_tooth" || selectItem?.typeId === "jurassic:velociraptor_claw" || selectItem?.typeId === "jurassic:plesiosaurus_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_velociraptor");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:mammoth_fossil" || selectItem?.typeId === "jurassic:fossil_mammoth_tusk") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_mammoth");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:mammoth_bones" || selectItem?.typeId === "jurassic:mammoth_tusk" || selectItem?.typeId === "jurassic:mammoth_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_mammoth");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:smilodon_fossil" || selectItem?.typeId === "jurassic:fossil_sabre_tooth") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_smilodon");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:smilodon_bones" || selectItem?.typeId === "jurassic:sabre_tooth" || selectItem?.typeId === "jurassic:smilodon_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_smilodon");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:dodo_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_dodo");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:dodo_bones" || selectItem?.typeId === "jurassic:rawdodo") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_dodo");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:brachiosaurus_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_brachiosaurus");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:brachiosaurus_bones" || selectItem?.typeId === "jurassic:brachiosaurus_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_brachiosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:stego_fossil" || selectItem?.typeId === "jurassic:fossilthagomizer" || selectItem?.typeId === "jurassic:fossil_stego_foot") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_stegosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:stegosaurus_bones" || selectItem?.typeId === "jurassic:thagomizer" || selectItem?.typeId === "jurassic:stegosaurus_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_stegosaurus");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:triceratops_fossil" || selectItem?.typeId === "jurassic:fossil_triceratops_horn") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv1_triceratops");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:triceratops_bones" || selectItem?.typeId === "jurassic:triceratops_horn" || selectItem?.typeId === "jurassic:triceratops_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_triceratops");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (block.permutation.getState('jurassic:disc') && selectItem?.typeId === "jurassic:pteranodon_fossil") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_pteranodon");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:disc')) {
                if (selectItem?.typeId === "jurassic:pteranodon_bones" || selectItem?.typeId === "jurassic:pteranodon_membrane" || selectItem?.typeId === "jurassic:pteranodon_flesh") {
                    const currentPermutation = block.permutation;
                    const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                    if (!selectItem.hasItem()) return;

                    if (player.getGameMode() !== GameMode.creative) {
                        if (selectItem.amount > 1) {
                            selectItem.amount--;
                        } else {
                            selectItem.setItem(undefined);
                        }
                    }
                    dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());

                    if (cardinalDirectionState === undefined) {
                        return;
                    }

                    try {
                        block.setType("jurassic:extractor_lv3_pteranodon");

                        let newPermutation = block.permutation;
                        newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                        block.setPermutation(newPermutation);
                    } catch (err) {
                    }
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_scale_tree_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_scale_tree_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_montsechia_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_montsechia_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_tall_cycad_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_tall_cycad_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_coelacanth_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_coelacanth_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
            if (selectItem?.typeId === "jurassic:lv1_nautilus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_nautilus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_mosasaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_mosasaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_plesiosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_plesiosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:storage_disk1") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_dilophosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_spinosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_spinosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_velociraptor_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_velociraptor_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:dodo_storage_disk0") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_dodo_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_mammoth_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_mammoth_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_smilodon_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_smilodon_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_brachiosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_brachiosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_stegosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_stegosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_triceratops_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_triceratops_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv1_pteranodon_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv1_pteranodon_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_scale_tree_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_scale_tree_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_montsechia_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_montsechia_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_tall_cycad_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_tall_cycad_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_coelacanth_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_coelacanth_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
            if (selectItem?.typeId === "jurassic:lv2_nautilus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_nautilus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_mosasaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_mosasaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_plesiosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_plesiosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:storage_disk2") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_dilophosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_spinosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_spinosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_velociraptor_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_velociraptor_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:dodo_storage_disk1") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_dodo_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_mammoth_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_mammoth_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_smilodon_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_smilodon_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_brachiosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_brachiosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_stegosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_stegosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_triceratops_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_triceratops_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (selectItem?.typeId === "jurassic:lv2_pteranodon_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv2_pteranodon_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_scale_tree_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_scale_tree_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_montsechia_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_montsechia_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_tall_cycad_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_tall_cycad_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_coelacanth_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_coelacanth_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_nautilus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_nautilus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_mosasaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_mosasaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_plesiosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_plesiosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:storage_disk3") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_dilophosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_spinosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_spinosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_velociraptor_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_velociraptor_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:dodo_storage_disk2") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_dodo_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_mammoth_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_mammoth_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_smilodon_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_smilodon_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_brachiosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_brachiosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_stegosaurus_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_stegosaurus_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_triceratops_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_triceratops_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }

            if (block.permutation.getState('jurassic:syringe') && selectItem?.typeId === "jurassic:lv3_pteranodon_dna") {
                const currentPermutation = block.permutation;
                const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_white", block.center());

                if (cardinalDirectionState === undefined) {
                    return;
                }

                try {
                    block.setType("jurassic:extractor_lv3_pteranodon_block");

                    let newPermutation = block.permutation;
                    newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                    block.setPermutation(newPermutation);
                } catch (err) {
                }
            }
        }
    });
});