import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_dodo_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:dodo_storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_dodo_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:dodo_storage_disk1", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_dodo_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:dodo_storage_disk2", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:dodo_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:dodo_full", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_mammoth_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_mammoth_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_mammoth_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_mammoth_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_mammoth_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_mammoth_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:mammoth_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:mammoth_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_smilodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_smilodon_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_smilodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_smilodon_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_smilodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_smilodon_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:smilodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:smilodon_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});