import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_scale_tree_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_scale_tree_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_scale_tree_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_scale_tree_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_scale_tree_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_scale_tree_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:scale_tree_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:scale_tree_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_tall_cycad_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_tall_cycad_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_tall_cycad_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_tall_cycad_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_tall_cycad_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_tall_cycad_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:tall_cycad_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:tall_cycad_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_montsechia_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_montsechia_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_montsechia_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_montsechia_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_montsechia_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_montsechia_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:montsechia_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:montsechia_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});