import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv1_pteranodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv1_pteranodon_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv2_pteranodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv2_pteranodon_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:lv3_pteranodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:lv3_pteranodon_dna", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:pteranodon_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:pteranodon_dna", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:storage_disk0", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:extractor_block");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});