import { world, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:medstation_tranq', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("minecraft:glass_bottle", 1), block.center());
                dimension.spawnItem(new ItemStack("jurassic:tranquilizer_item", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:medstation");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:medstation_flu', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:flu_vaccine", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:medstation");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:medstation_hookworms', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:hookworms_vaccine", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:medstation");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:medstation_rabies', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:rabies_vaccine", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:medstation");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:medstation_rot_jaw', {
        onPlayerInteract(event) {
            const { block, dimension } = event;
            const currentPermutation = block.permutation;
            const cardinalDirectionState = currentPermutation.getState("minecraft:cardinal_direction");

            if (block.permutation.getState('jurassic:loot')) {
                dimension.spawnItem(new ItemStack("jurassic:rot_jaw_vaccine", 1), block.center());
            }

            if (cardinalDirectionState === undefined) {
                return;
            }

            try {
                block.setType("jurassic:medstation");

                let newPermutation = block.permutation;
                newPermutation = newPermutation.withState("minecraft:cardinal_direction", cardinalDirectionState);
                block.setPermutation(newPermutation);
            } catch (err) {
            }
        }
    });
});