import { world, EquipmentSlot, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:sifter_interact', {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "minecraft:sand" || selectItem?.typeId === "minecraft:gravel") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:sifter_timersg");
            }

            if (selectItem?.typeId === "jurassic:unknown_fossil") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.spawnParticle("jurassic:completion_particle_yellow", block.center());
                block.setType("jurassic:sifter_timeruf");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:sifter_timersg', {
        onTick(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:sg_timer')) {
                block.setPermutation(block.permutation.withState('jurassic:sg_loot', true));
                block.setPermutation(block.permutation.withState('jurassic:sg_timer', false));
                dimension.spawnParticle("jurassic:completion_particle_green", block.center());
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:sifter_timeruf', {
        onTick(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:uf_timer')) {
                block.setPermutation(block.permutation.withState('jurassic:uf_loot', true));
                block.setPermutation(block.permutation.withState('jurassic:uf_timer', false));
                dimension.spawnParticle("jurassic:completion_particle_green", block.center());
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:sifter_sg_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:sg_loot')) {
                const { x, y, z } = block.center();
                dimension.runCommand(`loot spawn ${x} ${y} ${z} loot "blocks/jurassic_sifter_sg"`);
                block.setType("jurassic:sifter_block");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:sifter_uf_loot', {
        onPlayerInteract(event) {
            const { block, dimension } = event;

            if (block.permutation.getState('jurassic:uf_loot')) {
                const { x, y, z } = block.center();
                dimension.runCommand(`loot spawn ${x} ${y} ${z} loot "blocks/jurassic_sifter_uf"`);
                block.setType("jurassic:sifter_block");
            }
        }
    });
});