import { world, EquipmentSlot } from "@minecraft/server";

const ore = [
  { id: "jurassic:permafrost" },
  { id: "jurassic:cenozoicfossil" },
  { id: "jurassic:cretaceousfossil" },
  { id: "jurassic:fossilore" },
  { id: "jurassic:triassicore" },
  { id: "jurassic:paleozoicore" }
]

const randomInt = (min, max) => Math.floor(Math.random() * (max - min + 1)) + min;

world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry }) => {
  blockComponentRegistry.registerCustomComponent("jurassic:ore_xp", {
    onPlayerDestroy({ block, dimension, player }) {
      if (player.getGameMode() === "creative") return;

      const equippable = player?.getComponent("minecraft:equippable");
      if (!equippable) return;

      const itemStack = equippable.getEquipment(EquipmentSlot.Mainhand);

      if (itemStack?.typeId !== "minecraft:iron_pickaxe" || itemStack?.typeId !== "minecraft:diamond_pickaxe" || itemStack?.typeId !== "minecraft:netherite_pickaxe") return; // Exit if the player isn't holding a pickaxe

      const enchantable = itemStack.getComponent("minecraft:enchantable");
      const silkTouch = enchantable?.getEnchantment("silk_touch");
      if (silkTouch) return;

      const xpAmount = randomInt(0, 3);

      for (let i = 0; i < xpAmount; i++) {
        dimension.spawnEntity("minecraft:xp_orb", block.location);
      }
    }
  });
});