import { EquipmentSlot, GameMode, ItemStack, world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:cycad_give', {
        onPlayerInteract(event) {
            const { block, dimension, player, } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;
            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);
            const effectLocation = block.center();
            if (selectItem?.typeId === "minecraft:bone_meal") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                dimension.playSound("item.bone_meal.use", effectLocation);
                dimension.spawnParticle("minecraft:crop_growth_emitter", effectLocation);
                dimension.spawnItem(new ItemStack("jurassic:small_cycad_item", 1), block.center());
            }
        }
    })
})