import { EquipmentSlot, GameMode, world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(ev => {
    ev.blockComponentRegistry.registerCustomComponent('jurassic:panicum_sapling', {
        onPlayerInteract(event) {
            const { block, dimension, player } = event;
            const equippable = player.getComponent("minecraft:equippable");
            if (!equippable) return;

            const selectItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            if (selectItem?.typeId === "minecraft:bone_meal") {
                if (!selectItem.hasItem()) return;

                if (player.getGameMode() !== GameMode.creative) {
                    if (selectItem.amount > 1) {
                        selectItem.amount--;
                    } else {
                        selectItem.setItem(undefined);
                    }
                }
                const effectLocation = block.center();
                dimension.playSound("item.bone_meal.use", effectLocation);
                dimension.spawnParticle("minecraft:crop_growth_emitter", effectLocation);
                block.setType("jurassic:tall_panicum");
                dimension.runCommandAsync(`setblock  ${block.location.x} ${block.location.y + 1} ${block.location.z} jurassic:tall_panicum_top`);
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(ev => {
    ev.blockComponentRegistry.registerCustomComponent('jurassic:panicum_tick', {
        onRandomTick(event) {
            const { block, dimension } = event;

            block.setType("jurassic:tall_panicum");
            dimension.runCommandAsync(`setblock  ${block.location.x} ${block.location.y + 1} ${block.location.z} jurassic:tall_panicum_top`);
        }
    });
});