import { world, EquipmentSlot, GameMode } from "@minecraft/server";

const slabs = [
  { id: "jurassic:charred_slab" },
  { id: "jurassic:scale_slab" },
  { id: "jurassic:dried_scale_slab" },
  { id: "jurassic:smooth_volcanic_slab" },
  { id: "jurassic:volcanic_brick_slab" }
];

world.beforeEvents.worldInitialize.subscribe(ev => {
  ev.blockComponentRegistry.registerCustomComponent('jurassic:scale_slaby', {
    onPlayerInteract(e) {
      const { player, block, face } = e;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectedItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

      if (selectedItem?.typeId === "jurassic:scale_slab" && !block.permutation.getState('jurassic:double')) {
        const half = block.permutation.getState('minecraft:vertical_half');
        const bottomUp = half === 'bottom' && face === 'Up';
        const topBottom = half === 'top' && face === 'Down';
        if (bottomUp || topBottom) {
          if (!selectedItem.hasItem()) return;

          if (player.getGameMode() !== GameMode.creative) {
            if (selectedItem.amount > 1) {
              selectedItem.amount--;
            } else {
              selectedItem.setItem(undefined);
            }
          }
          block.setPermutation(block.permutation.withState('jurassic:double', true));
          player.playSound('use.stone');
        }
      }
    }
  });
});

world.beforeEvents.worldInitialize.subscribe(ev => {
  ev.blockComponentRegistry.registerCustomComponent('jurassic:dried_scale_slaby', {
    onPlayerInteract(e) {
      const { player, block, face } = e;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectedItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

      if (selectedItem?.typeId === "jurassic:dried_scale_slab" && !block.permutation.getState('jurassic:double')) {
        const half = block.permutation.getState('minecraft:vertical_half');
        const bottomUp = half === 'bottom' && face === 'Up';
        const topBottom = half === 'top' && face === 'Down';
        if (bottomUp || topBottom) {
          if (!selectedItem.hasItem()) return;

          if (player.getGameMode() !== GameMode.creative) {
            if (selectedItem.amount > 1) {
              selectedItem.amount--;
            } else {
              selectedItem.setItem(undefined);
            }
          }
          block.setPermutation(block.permutation.withState('jurassic:double', true));
          player.playSound('use.stone');
        }
      }
    }
  });
});

world.beforeEvents.worldInitialize.subscribe(ev => {
  ev.blockComponentRegistry.registerCustomComponent('jurassic:charred_slaby', {
    onPlayerInteract(e) {
      const { player, block, face } = e;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectedItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

      if (selectedItem?.typeId === "jurassic:charred_slab" && !block.permutation.getState('jurassic:double')) {
        const half = block.permutation.getState('minecraft:vertical_half');
        const bottomUp = half === 'bottom' && face === 'Up';
        const topBottom = half === 'top' && face === 'Down';
        if (bottomUp || topBottom) {
          if (!selectedItem.hasItem()) return;

          if (player.getGameMode() !== GameMode.creative) {
            if (selectedItem.amount > 1) {
              selectedItem.amount--;
            } else {
              selectedItem.setItem(undefined);
            }
          }
          block.setPermutation(block.permutation.withState('jurassic:double', true));
          player.playSound('use.stone');
        }
      }
    }
  });
});

world.beforeEvents.worldInitialize.subscribe(ev => {
  ev.blockComponentRegistry.registerCustomComponent('jurassic:smooth_volcanic_slaby', {
    onPlayerInteract(e) {
      const { player, block, face } = e;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectedItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

      if (selectedItem?.typeId === "jurassic:smooth_volcanic_slab" && !block.permutation.getState('jurassic:double')) {
        const half = block.permutation.getState('minecraft:vertical_half');
        const bottomUp = half === 'bottom' && face === 'Up';
        const topBottom = half === 'top' && face === 'Down';
        if (bottomUp || topBottom) {
          if (!selectedItem.hasItem()) return;

          if (player.getGameMode() !== GameMode.creative) {
            if (selectedItem.amount > 1) {
              selectedItem.amount--;
            } else {
              selectedItem.setItem(undefined);
            }
          }
          block.setPermutation(block.permutation.withState('jurassic:double', true));
          player.playSound('use.stone');
        }
      }
    }
  });
});

world.beforeEvents.worldInitialize.subscribe(ev => {
  ev.blockComponentRegistry.registerCustomComponent('jurassic:volcanic_brick_slaby', {
    onPlayerInteract(e) {
      const { player, block, face } = e;
      const equippable = player.getComponent("minecraft:equippable");
      if (!equippable) return;

      const selectedItem = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

      if (selectedItem?.typeId === "jurassic:volcanic_brick_slab" && !block.permutation.getState('jurassic:double')) {
        const half = block.permutation.getState('minecraft:vertical_half');
        const bottomUp = half === 'bottom' && face === 'Up';
        const topBottom = half === 'top' && face === 'Down';
        if (bottomUp || topBottom) {
          if (!selectedItem.hasItem()) return;

          if (player.getGameMode() !== GameMode.creative) {
            if (selectedItem.amount > 1) {
              selectedItem.amount--;
            } else {
              selectedItem.setItem(undefined);
            }
          }
          block.setPermutation(block.permutation.withState('jurassic:double', true));
          player.playSound('use.stone');
        }
      }
    }
  });
});