import { world, ItemStack, EquipmentSlot } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(data => {
    data.blockComponentRegistry.registerCustomComponent('jurassic:tar_bucket', {
        onPlayerInteract(event) {
            const { block, player } = event;
            const equipment = player.getComponent('equippable');
            const selectItem = equipment.getEquipment('Mainhand');

            if (selectItem?.typeId === "minecraft:bucket") {
                if (player.getGameMode() !== "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('jurassic:tar_bucket', 1));
                }
                if (player.getGameMode() === "creative") {
                    equipment.setEquipment('Mainhand', new ItemStack('jurassic:tar_bucket', 1));
                }
                block.setType("minecraft:air");
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.itemComponentRegistry.registerCustomComponent('jurassic:bucket_tar', {
        onUseOn({ source }) {
            const equippable = source?.getComponent("minecraft:equippable");
            if (!equippable) return;

            const mainhand = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            mainhand.setItem(new ItemStack("minecraft:bucket"));
        }
    });
});