import { world, EquipmentSlot, ItemStack } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(data => {
    data.itemComponentRegistry.registerCustomComponent('jurassic:crossbow', {
        onCompleteUse(event) {
            const { source } = event;

            const equippable = source?.getComponent("minecraft:equippable");
            if (!equippable) return;

            const mainhand = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);
            const offhand = equippable.getEquipmentSlot(EquipmentSlot.Offhand);

            if (offhand?.typeId === "jurassic:tranquilizer_item") {
                mainhand.setItem(new ItemStack("jurassic:reinforced_crossbow_charged"));
            }
            if (offhand?.typeId !== "jurassic:tranquilizer_item") {
                mainhand.setItem(new ItemStack("jurassic:reinforced_crossbow"));
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(data => {
    data.itemComponentRegistry.registerCustomComponent('jurassic:crossbow_charged', {
        onCompleteUse(event) {
            const { source } = event;

            const equippable = source?.getComponent("minecraft:equippable");
            if (!equippable) return;

            const mainhand = equippable.getEquipmentSlot(EquipmentSlot.Mainhand);

            mainhand.setItem(new ItemStack("jurassic:reinforced_crossbow"));
        }
    });
});